/*****************************************************************************
 *
 * This software module was originally developed by
 *
 *   Noel Brady (TELTEC IRELAND / ACTS-MoMuSys)
 *
 * in the course of development of the MPEG-4 Video (ISO/IEC 14496-2) standard.
 * This software module is an implementation of a part of one or more MPEG-4
 * Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video (ISO/IEC
 * 14496-2) standard.
 *
 * ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 14496-2) standard free
 * license to this software module or modifications thereof for use in hardware
 * or software products claiming conformance to the MPEG-4 Video (ISO/IEC
 * 14496-2) standard.
 *
 * Those intending to use this software module in hardware or software products
 * are advised that its use may infringe existing patents. The original
 * developer of this software module and his/her company, the subsequent
 * editors and their companies, and ISO/IEC have no liability for use of this
 * software module or modifications thereof in an implementation. Copyright is
 * not released for non MPEG-4 Video (ISO/IEC 14496-2) Standard conforming
 * products.
 *
 * ACTS-MoMuSys partners retain full right to use the code for his/her own
 * purpose, assign or donate the code to a third party and to inhibit third
 * parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2) Standard
 * conforming products. This copyright notice must be included in all copies or
 * derivative works.
 *
 * Copyright (c) 1997
 *
 *****************************************************************************/

#ifndef _ALP_MODE_TABLES_H_
#define _ALP_MODE_TABLES_H_

static Char *MMB_TYPE0[7] = {"1","01","00001","000001","0001","0010","0011"};
static Char *MMB_TYPE1[7] = {"01","1","00001","000001","001","0000001","0001"};
static Char *MMB_TYPE2[7] = {"0001","001","1","000001","01","0000001","00001"};
static Char *MMB_TYPE3[7] = {"1","0001","000001","001","01","0000001","00001"};
static Char *MMB_TYPE4[7] = {"011","001","0001","00001","1","000001","010"};
static Char *MMB_TYPE5[7] = {"01","0001","00001","000001","001","11","10"};
static Char *MMB_TYPE6[7] = {"001","0001","00001","000001","01","10","11"};

static Char *IMB_TYPE[81][3] =					/* Noel/E14 */
{
/* 0 */ 	{ "1" , "001", "01"},
/* 1 */		{ "001", "01",  "1"},
/* 2 */		{ "01", "001",  "1"},
/* 3 */ 	{ "1" ,	"001", "01"},
/* 4 */ 	{ "1" , "01", "001"},
/* 5 */ 	{ "1" , "01", "001"},
/* 6 */ 	{ "1" , "001", "01"},
/* 7 */ 	{ "1" , "01", "001"},
/* 8 */		{ "01", "001",  "1"},
/* 9 */		{ "001", "01",	"1"},
/* 10 */ 	{ "1" , "01", "001"},
/* 11 */ 	{ "1" , "01", "001"},
/* 12 */	{ "001", "01",	"1"},
/* 13 */ 	{ "1" , "01", "001"},
/* 14 */	{ "01", "1" , "001"},
/* 15 */	{ "001", "01",	"1"},
/* 16 */ 	{ "1" , "01", "001"},
/* 17 */ 	{ "1" , "01", "001"},
/* 18 */        { "01",	"001",	"1"},
/* 19 */ 	{ "1" , "01", "001"},
/* 20 */	{ "001", "01",	"1"},
/* 21 */        { "01",	"001",	"1"},
/* 22 */ 	{ "1" , "01", "001"},
/* 23 */	{ "001", "01",	"1"},
/* 24 */        { "01",	"001",	"1"},
/* 25 */	{ "001", "01",	"1"},
/* 26 */	{ "001", "01",	"1"},
/* 27 */ 	{ "1" , "01", "001"},
/* 28 */ 	{ "1" , "01", "001"},
/* 29 */ 	{ "1" , "01", "001"},
/* 30 */ 	{ "1" , "01", "001"},
/* 31 */ 	{ "1" , "01", "001"},
/* 32 */ 	{ "1" , "01", "001"},
/* 33 */ 	{ "1" , "01", "001"},
/* 34 */ 	{ "1" , "01", "001"},
/* 35 */	{ "001", "01",	"1"},
/* 36 */ 	{ "1" , "01", "001"},
/* 37 */	{ "001", "01",	"1"},
/* 38 */	{ "001", "01",	"1"},
/* 39 */ 	{ "1" , "01", "001"},
/* 40 */	{ "001", "1",  "01"},
/* 41 */	{ "001", "01",	"1"},
/* 42 */ 	{ "1" , "01", "001"},
/* 43 */	{ "001", "1" , "01"},
/* 44 */	{ "001", "01",	"1"},
/* 45 */ 	{ "1" , "01", "001"},
/* 46 */	{ "001", "01",	"1"},
/* 47 */        { "01",	"001",	"1"},
/* 48 */ 	{ "1" , "01", "001"},
/* 49 */	{ "001", "01",	"1"},
/* 50 */        { "01",	"001",	"1"},
/* 51 */	{ "1" ,	"001", "01"},
/* 52 */	{ "001", "1" , "01"},
/* 53 */        { "01",	"001",	"1"},
/* 54 */	{ "1" ,	"001", "01"},
/* 55 */        { "01",	"001",	"1"},
/* 56 */        { "01",	"001",	"1"},
/* 57 */ 	{ "1" , "01", "001"},
/* 58 */ 	{ "1" , "01", "001"},
/* 59 */ 	{ "1" , "01", "001"},
/* 60 */ 	{ "1" , "01", "001"},
/* 61 */ 	{ "1" , "01", "001"},
/* 62 */        { "01",	"001",	"1"},
/* 63 */ 	{ "1" , "01", "001"},
/* 64 */	{ "001", "01",	"1"},
/* 65 */	{ "001", "01",	"1"},
/* 66 */        { "01",	"001",	"1"},
/* 67 */	{ "001", "1" , "01"},
/* 68 */	{ "001", "1" , "01"},
/* 69 */        { "01",	"001",	"1"},
/* 70 */	{ "001", "1" , "01"},
/* 71 */	{ "001", "01",	"1"},
/* 72 */	{ "1" ,	"001", "01"},
/* 73 */	{ "001", "01",	"1"},
/* 74 */        { "01",	"001",	"1"},
/* 75 */        { "01",	"001",	"1"},
/* 76 */	{ "001", "1" , "01"},
/* 77 */	{ "001", "01",	"1"},
/* 78 */	{ "1" ,	"001", "01"},
/* 79 */	{ "001", "1" , "01"},
/* 80 */	{ "001", "01",	"1"},
};

/* begin : added for OBSS by Samsung AIT (1999-09-29) */
/* for P-VOP mode coding in the enhancement layer */
static Char *IMB_ENH_TYPE[2] = {"1","01"};

/* for B-VOP mode coding in the enhancement layer */
static Char *MMB_ENH_TYPE1[4] = {"1","01","001","000"};
static Char *MMB_ENH_TYPE2[4] = {"110","0","10","111"};
static Char *MMB_ENH_TYPE3[4] = {"001","01","1","000"};
static Char *MMB_ENH_TYPE4[4] = {"110","0","111","10"};
/* end : added for OBSS by Samsung AIT (1999-09-29) */

#endif /* _ALP_MODE_TABLES_H_ */
