/*****************************************************************************
 *
 * This software module was originally developed by
 *
 *   Michael Wollborn (TUH / ACTS-MoMuSyS)
 *
 * in the course of development of the MPEG-4 Video (ISO/IEC 14496-2) standard.
 * This software module is an implementation of a part of one or more MPEG-4
 * Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video (ISO/IEC
 * 14496-2) standard.
 *
 * ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 14496-2) standard free
 * license to this software module or modifications thereof for use in hardware
 * or software products claiming conformance to the MPEG-4 Video (ISO/IEC
 * 14496-2) standard.
 *
 * Those intending to use this software module in hardware or software products
 * are advised that its use may infringe existing patents. The original
 * developer of this software module and his/her company, the subsequent
 * editors and their companies, and ISO/IEC have no liability for use of this
 * software module or modifications thereof in an implementation. Copyright is
 * not released for non MPEG-4 Video (ISO/IEC 14496-2) Standard conforming
 * products.
 *
 * ACTS-MoMuSys partners retain full right to use the code for his/her own
 * purpose, assign or donate the code to a third party and to inhibit third
 * parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2) Standard
 * conforming products. This copyright notice must be included in all copies or
 * derivative works.
 *
 * Copyright (c) 1997
 *
 *****************************************************************************/

static Int intra_max_level[2][64] = {
				     {27, 10,  5,  4,  3,  3,  3,  3, 
				       2,  2,  1,  1,  1,  1,  1,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
                                     },

				      {8,  3,  2,  2,  2,  2,  2,  1, 
				       1,  1,  1,  1,  1,  1,  1,  1,
				       1,  1,  1,  1,  1,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0
				    }
                                   };


static Int inter_max_level[2][64] = {
				     {12,  6,  4,  3,  3,  3,  3,  2, 
				       2,  2,  2,  1,  1,  1,  1,  1,
				       1,  1,  1,  1,  1,  1,  1,  1,
				       1,  1,  1,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0},

				      {3,  2,  1,  1,  1,  1,  1,  1, 
				       1,  1,  1,  1,  1,  1,  1,  1,
				       1,  1,  1,  1,  1,  1,  1,  1,
				       1,  1,  1,  1,  1,  1,  1,  1,
				       1,  1,  1,  1,  1,  1,  1,  1,
				       1,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0,
				       0,  0,  0,  0,  0,  0,  0,  0}
				    };


static Int intra_max_run0[28] = { 999, 14,  9,  7,  3,  2,  1,   
				    1,  1,  1,  1,  0,  0,  0, 
				    0,  0,  0,  0,  0,  0,  0,
				    0,  0,  0,  0,  0,  0,  0
				};


static Int intra_max_run1[9] = { 999, 20,  6,  
				   1,  0,  0,  
				   0,  0,  0
			       };

static Int inter_max_run0[13] = { 999, 
				   26, 10,  6,  2,  1,  1,   
				    0,  0,  0,  0,  0,  0
				};


static Int inter_max_run1[4] = { 999, 40,  1,  0 };

