/******************************************************************************
 *                                                                          
 * This software module was originally developed by 
 *
 *   Cecile Dufour (LEP / ACTS-MoMuSys)
 *   Frederic Dufaux (Digital Equipment Corp.)
 *
 * and edited by 
 *
 *   Yoshinori Suzuki (Hitachi, Ltd.)
 *
 * in the course of development of the MPEG-4 Video (ISO/IEC 14496-2) standard.
 * This software module is an implementation of a part of one or more MPEG-4 
 * Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 14496-2) standard free 
 * license to this software module or modifications thereof for use in hardware
 * or software products claiming conformance to the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * Those intending to use this software module in hardware or software products
 * are advised that its use may infringe existing patents. The original 
 * developer of this software module and his/her company, the subsequent 
 * editors and their companies, and ISO/IEC have no liability for use of this 
 * software module or modifications thereof in an implementation. Copyright is 
 * not released for non MPEG-4 Video (ISO/IEC 14496-2) standard conforming 
 * products. 
 *
 * ACTS-MoMuSys partners retain full right to use the code for his/her own 
 * purpose, assign or donate the code to a third party and to inhibit third 
 * parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2) standard
 * conforming products. This copyright notice must be included in all copies or
 * derivative works. 
 *
 * Copyright (c) 1997
 *
 *****************************************************************************/

/***********************************************************HeaderBegin*******
 *                                                                         
 * File:	sprite_util.h
 *
 * Author:	Cecile Dufour, Frederic Dufaux
 * Created:	20.02.97
 *                                                                         
 * Description: 
 *
 * Notes: 	
 *
 * Modified:
 *	08.15.97 : C. Dufour: included fields for low-latency static sprite	
 *			
 *
 ***********************************************************HeaderEnd*********/

/************************    INCLUDE FILES    ********************************/

#ifndef _SPRITE_UTIL_H_
#define _SPRITE_UTIL_H_


#include "momusys.h"
#include "vm_common_defs.h"
#include "mom_structs.h"

#define STOP		0		/* vop coding modes */
#define PIECE		1
#define UPDATE		2
#define PAUSE		3	

#define	NON_TRANSMIT_BLOCK		0
#define	BLOCK_PIECE_TO_TRANSMIT		1
#define BLOCK_UPDATE_TO_TRANSMIT	2
#define BLOCK_TRANSMIT_END		3


#include "sprite_util.p"

	
#endif /* _SPRITE_UTIL_H */





