/*****************************************************************************
 *
 * This software module was originally developed by
 *
 *   Robert Danielsen (Telenor / ACTS-MoMuSyS)
 *
 * in the course of development of the MPEG-4 Video (ISO/IEC 14496-2) standard.
 * This software module is an implementation of a part of one or more MPEG-4
 * Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video (ISO/IEC
 * 14496-2) standard.
 *
 * ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 14496-2) standard free
 * license to this software module or modifications thereof for use in hardware
 * or software products claiming conformance to the MPEG-4 Video (ISO/IEC
 * 14496-2) standard.
 *
 * Those intending to use this software module in hardware or software products
 * are advised that its use may infringe existing patents. The original
 * developer of this software module and his/her company, the subsequent
 * editors and their companies, and ISO/IEC have no liability for use of this
 * software module or modifications thereof in an implementation. Copyright is
 * not released for non MPEG-4 Video (ISO/IEC 14496-2) Standard conforming
 * products.
 *
 * ACTS-MoMuSys partners retain full right to use the code for his/her own
 * purpose, assign or donate the code to a third party and to inhibit third
 * parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2) Standard
 * conforming products. This copyright notice must be included in all copies or
 * derivative works.
 *
 * Copyright (c) 1996
 *
 *****************************************************************************/

/***********************************************************HeaderBegin*******
 *                                                                         
 * File:	text_util.h
 *
 * Author:	
 * Created:	
 *                                                                         
 * Description: 
 *
 * Notes: 	
 *
 * Modified:	06-AUG-1996: Removed "comma" in last line of zigzag field
 *			     (M.Wollborn)
 *	06.11.96 Robert Danielsen: Added new zigzag-tables
 *	28.01.97 Robert Danielsen: Removed zigzag-tables. Now in zigzag.h.
 *      01.04.01 Osamu Sunohara (SONY): Variables for Studio Profile
 *
 ***********************************************************HeaderEnd*********/

#ifndef _TEXT_UTIL_H_
#define _TEXT_UTIL_H_

#include "momusys.h"
#include "vm_common_defs.h"


#ifndef PI
# ifdef M_PI
#  define PI M_PI
# else
#  define PI 3.14159265358979323846
# endif
#endif


/* class for macroblock data */

typedef struct {
  Int lum[16][16];
  Int Cb[8][8];
  Int Cr[8][8];

/* 01.04.01: Studio Profile */
  Int Cb_ext[3][8][8];
  Int Cr_ext[3][8][8];
/* 01.04.01: Studio Profile */
  
} Macroblock;


#include "text_util.p"
#endif
