/******************************************************************************
 *                                                                          
 * This software module was originally developed by 
 *
 * Osamu Sunohara (SONY)
 *
 * in the course of development of the MPEG-4 Video (ISO/IEC 14496-2) standard.
 * This software module is an implementation of a part of one or more MPEG-4 
 * Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 14496-2) standard free 
 * license to this software module or modifications thereof for use in hardware
 * or software products claiming conformance to the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * Those intending to use this software module in hardware or software products
 * are advised that its use may infringe existing patents. The original 
 * developer of this software module and his/her company, the subsequent 
 * editors and their companies, and ISO/IEC have no liability for use of this 
 * software module or modifications thereof in an implementation. Copyright is 
 * not released for non MPEG-4 Video (ISO/IEC 14496-2) standard conforming 
 * products. 
 *
 * ACTS-MoMuSys partners retain full right to use the code for his/her own 
 * purpose, assign or donate the code to a third party and to inhibit third 
 * parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2) standard
 * conforming products. This copyright notice must be included in all copies or
 * derivative works. 
 *
 * Copyright (c) 1997
 *
 *****************************************************************************/


/***********************************************************HeaderBegin*******
 *                                                                         
 * File:	mbvlc_studio.h
 *
 * Author:	Osamu Sunohara(SONY)
 * Created:	01.04.01
 *                                                                         
 * Description: vlc tables for encoding studio video objects
 *
 * Notes: 	Idea taken from MPEG-2 software simulation group
 *
 * Modified:	
 *
 ***********************************************************HeaderEnd*********/

/************************    INCLUDE FILES    ********************************/

#ifndef _MBVLC_STUDIO_H_
#define _MBVLC_STUDIO_H_

typedef struct
{
  U_Int code; /* right justified */
  Int len;
} MBVLCtable_studio;


static MBVLCtable_studio macroblock_type_studio[7] =
{
  {0x01, 1}, {0x01, 2}, {0x01, 3}, {0x03, 5},
  {0x02, 5}, {0x01, 5}, {0x01, 6}
};

static MBVLCtable_studio coded_block_pattern_420_studio[64] =
{
  {0x01, 9}, {0x0b, 5}, {0x09, 5}, {0x0d, 6},
  {0x0d, 4}, {0x17, 7}, {0x13, 7}, {0x1f, 8},
  {0x0c, 4}, {0x16, 7}, {0x12, 7}, {0x1e, 8},
  {0x13, 5}, {0x1b, 8}, {0x17, 8}, {0x13, 8},
  {0x0b, 4}, {0x15, 7}, {0x11, 7}, {0x1d, 8},
  {0x11, 5}, {0x19, 8}, {0x15, 8}, {0x11, 8},
  {0x0f, 6}, {0x0f, 8}, {0x0d, 8}, {0x03, 9},
  {0x0f, 5}, {0x0b, 8}, {0x07, 8}, {0x07, 9},
  {0x0a, 4}, {0x14, 7}, {0x10, 7}, {0x1c, 8},
  {0x0e, 6}, {0x0e, 8}, {0x0c, 8}, {0x02, 9},
  {0x10, 5}, {0x18, 8}, {0x14, 8}, {0x10, 8},
  {0x0e, 5}, {0x0a, 8}, {0x06, 8}, {0x06, 9},
  {0x12, 5}, {0x1a, 8}, {0x16, 8}, {0x12, 8},
  {0x0d, 5}, {0x09, 8}, {0x05, 8}, {0x05, 9},
  {0x0c, 5}, {0x08, 8}, {0x04, 8}, {0x04, 9},
  {0x07, 3}, {0x0a, 5}, {0x08, 5}, {0x0c, 6}
};

static MBVLCtable_studio motion_code_studio[33] =
{
  {0x19,11}, {0x1b,11}, {0x1d,11}, {0x1f,11},
  {0x21,11}, {0x23,11}, {0x13,10}, {0x15,10},
  {0x17,10}, {0x07, 8}, {0x09, 8}, {0x0b, 8},
  {0x07, 7}, {0x03, 5}, {0x03, 4}, {0x03, 3},
  {0x01, 1}, {0x02, 3}, {0x02, 4}, {0x02, 5},
  {0x06, 7}, {0x0a, 8}, {0x08, 8}, {0x06, 8},
  {0x16,10}, {0x14,10}, {0x12,10}, {0x22,11},
  {0x20,11}, {0x1e,11}, {0x1c,11}, {0x1a,11},
  {0x18,11}
};

#endif /* _MBVLC_STUDIO_H */






