
/******************************************************************************
 *                                                                          
 * This software module was originally developed by 
 *
 *   Angel Pacheco (UPM-GTI / ACTS-MoMuSys)
 *   J. Ignacio Ronda (UPM-GTI / ACTS-MoMuSys)
 *
 * and edited by 
 *
 *   Angel Pacheco (UPM-GTI / ACTS-MoMuSys)
 *   Robert Danielsen (Telenor / ACTS-MoMuSys)
 *   Bruno Loret (CNET / ACTS-MoMuSys)
 *
 * in the course of development of the MPEG-4 Video (ISO/IEC 14496-2) standard.
 * This software module is an implementation of a part of one or more MPEG-4 
 * Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 14496-2) standard free 
 * license to this software module or modifications thereof for use in hardware
 * or software products claiming conformance to the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * Those intending to use this software module in hardware or software products
 * are advised that its use may infringe existing patents. The original 
 * developer of this software module and his/her company, the subsequent 
 * editors and their companies, and ISO/IEC have no liability for use of this 
 * software module or modifications thereof in an implementation. Copyright is 
 * not released for non MPEG-4 Video (ISO/IEC 14496-2) standard conforming 
 * products. 
 *
 * ACTS-MoMuSys partners retain full right to use the code for his/her own 
 * purpose, assign or donate the code to a third party and to inhibit third 
 * parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2) standard
 * conforming products. This copyright notice must be included in all copies or
 * derivative works. 
 *
 * Copyright (c) 1997
 *
 *****************************************************************************/

/***********************************************************HeaderBegin*******
 *                                                                         
 * File:        mot_est.h
 *
 * Author:      UPM-GTI - J. Ignacio Ronda / Angel Pacheco
 *
 * Created:     2.2.96
 *                                                                         
 * Description: This is the header file for the motion functions.
 *              This file should be included in each source file where
 *              the motion functions are used. Since all required prototypes
 *              are included here, only this file must be included, not
 *              the ".proto" file.
 *
 * Notes:  
 *
 * Modified: 
 *      21.04.96 Robert Danielsen: New header.
 *      23.04.96 Bruno Loret: Non reentrant ifndef
 *      30.08.96 Angel Pacheco: B_BOUNDARY definition
 *      16.06.97 Angel Pacheco: Moved some types and defines to 
 *               "vm_common_defs.h"
 *      13.11.97 Angel Pacheco: formating and new header.
 *
 ***********************************************************HeaderEnd*********/

#ifndef _MOT_EST_H_
#define _MOT_EST_H_

#include "vm_common_defs.h"

#include "mot_est.p"
#include "mot_code.p"
#include "mot_est_mb.p"
#include "mot_vop.p"

#endif /* _MOT_EST_H_ */
