/******************************************************************************
 *                                                                          
 * This software module was originally developed by 
 *
 * Cor Quist (KPN / ACTS-MoMuSys).     			              	
 *
 * in the course of development of the MPEG-4 Video (ISO/IEC 14496-2) standard.
 * This software module is an implementation of a part of one or more MPEG-4 
 * Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 14496-2) standard free 
 * license to this software module or modifications thereof for use in hardware
 * or software products claiming conformance to the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * Those intending to use this software module in hardware or software products
 * are advised that its use may infringe existing patents. The original 
 * developer of this software module and his/her company, the subsequent 
 * editors and their companies, and ISO/IEC have no liability for use of this 
 * software module or modifications thereof in an implementation. Copyright is 
 * not released for non MPEG-4 Video (ISO/IEC 14496-2) standard conforming 
 * products. 
 *
 * ACTS-MoMuSys partners retain full right to use the code for his/her own 
 * purpose, assign or donate the code to a third party and to inhibit third 
 * parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2) standard
 * conforming products. This copyright notice must be included in all copies or
 * derivative works. 
 *
 * Copyright (c) 1997
 *
 *****************************************************************************/



/***********************************************************HeaderBegin*******
 *                                                                         
 * File:	text_bits.h
 *
 * Author:	Cor Quist
 * Created:	April 10, 1996
 *                                                                         
 * Description: 
 *
 * Notes: 	
 *
 * Modified:	21.04.96 Robert Danielsen: New header.
 *              23.04.96 Bruno Loret: Non reentrant ifndef
 *		        12.03.97 Minhua Zhou: added B_vops	
 *              11.12.97 Bob Eifrig: added interlaced statistics
 *              21.05.98 Ji Heon Kweon (HYUNDAI) : support for grayscale coding 
 *		03.03.99 Seishi TAKAMURA (NTT): added GMC coding
 *              01.04.01 Osamu Sunohara (SONY): variables for Studio Profile
 *
 ***********************************************************HeaderEnd*********/


#ifndef _TEXT_BITS_H_
#define _TEXT_BITS_H_


#include "momusys.h"
#include "text_defs.h"



/* struct for counting bits */

typedef struct {
  Int Y;
  Int C;
  Int vec;
  Int CBPY;
  Int CBPC; 
  Int MCBPC;
  Int MODB;
  Int CBPB;
  Int MBTYPE;
  Int COD;
  Int MB_Mode; 
  Int header;
  Int DQUANT;
  Int total;
  Int no_inter;
  Int no_inter4v;
  Int no_intra;
  Int no_GMC;	/* NTT for GMC coding */
  Int ACpred_flag;
  Int G;	/* HYUNDAI : (Grayscale) */
  Int CODA;	/* HYUNDAI : (Grayscale) */
  Int CBPA;	/* HYUNDAI : (Grayscale) */
  Int g_ACpred_flag;	/* HYUNDAI : (Grayscale) */
  Int no_field;
  Int no_skipped;
  Int no_Pskip;
  Int no_noDCT;
  Int fieldDCT;
  Int interlaced;
  Int Btype[7];
  Int Nmvs[3];

  /* 01.04.01: Studio Profile */
  Int no_transp;
  Int no_frame_framemc;
  Int no_frame_fieldmc;
  Int no_field_fieldmc;
  Int no_field_16x8mc;

  Int Ydc; 
  Int Yac; 
  Int Cdc; 
  Int Cac; 
  Int Cb_dc; 
  Int Cb_ac; 
  Int Cr_dc; 
  Int Cr_ac;

  Int Yac_inter; /*u*/
  Int Cac_inter; /*u*/
  Int Cb_ac_inter; /*u*/
  Int Cr_ac_inter; /*u*/

  Int Y_raw;
  Int Cb_raw;
  Int Cr_raw;
  Int G_raw;
  
  Int pattern_Y_intra[5];
  Int pattern_Cb_intra[5];
  Int pattern_Cr_intra[5];
  Int pattern_Y_inter[5];
  Int pattern_Cb_inter[5];
  Int pattern_Cr_inter[5];

  Int mbheader;
  Int UNCOMP;
  int CBP;
  int bitCBP;
  Int CBPCb; /*u*/
  Int CBPCr; /*u*/

  Int QUANT; /*u*/
  Int Gdc; /*u*/
  Int Gac; /*u*/
  Int g_QUANT; /*u*/
  Int g_fieldDCT; /*c*/
  Int g_interlaced; /*u*/
  
  Int over_uncompress_Y;
  Int over_uncompress_Cb;
  Int over_uncompress_Cr;
  Int over_uncompress_G;
  
  Int stuffing;
  /* 01.04.01: Studio Profile */
  
} Bits;
#include "text_bits.p"


#endif /* _TEXT_BITS_H_ */
