/******************************************************************************
 *                                                                          
 * This software module was originally developed by 
 *
 * Robert Danielsen (Telenor / ACTS-MoMuSys). 	    	              	
 *
 * and edited by 
 *
 * Minhua Zhou (HHI / ACTS-MoMuSys).   	  	 	              	
 * Luis Ducla-Soares (IST / ACTS-MoMuSys).
 * Osamu Sunohara (SONY)
 *
 * in the course of development of the MPEG-4 Video (ISO/IEC 14496-2) standard.
 * This software module is an implementation of a part of one or more MPEG-4 
 * Video (ISO/IEC 14496-2) tools as specified by the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * ISO/IEC gives users of the MPEG-4 Video (ISO/IEC 14496-2) standard free 
 * license to this software module or modifications thereof for use in hardware
 * or software products claiming conformance to the MPEG-4 Video (ISO/IEC 
 * 14496-2) standard. 
 *
 * Those intending to use this software module in hardware or software products
 * are advised that its use may infringe existing patents. The original 
 * developer of this software module and his/her company, the subsequent 
 * editors and their companies, and ISO/IEC have no liability for use of this 
 * software module or modifications thereof in an implementation. Copyright is 
 * not released for non MPEG-4 Video (ISO/IEC 14496-2) standard conforming 
 * products. 
 *
 * ACTS-MoMuSys partners retain full right to use the code for his/her own 
 * purpose, assign or donate the code to a third party and to inhibit third 
 * parties from using the code for non MPEG-4 Video (ISO/IEC 14496-2) standard
 * conforming products. This copyright notice must be included in all copies or
 * derivative works. 
 *
 * Copyright (c) 1997
 *
 *****************************************************************************/


/***********************************************************HeaderBegin*******
 *                                                                         
 * File:	vlc_studio.h
 *
 * Author:	Osamu Sunohara(SONY)
 * Created:	01.04.01
 *                                                                         
 * Description: vlc tables for encoding studio video objects
 *
 * Notes: 	Idea taken from MPEG-2 software simulation group
 *
 * Modified:	
 *
 ***********************************************************HeaderEnd*********/

/************************    INCLUDE FILES    ********************************/

#ifndef _VLC_STUDIO_H_
#define _VLC_STUDIO_H_

typedef struct
{
  U_Int code; /* right justified */
  Int len;
} VLCtable_studio;


static VLCtable_studio DCtab_lum_studio[19] =
{
  /*v001225*/
  {0x0e, 6}, {0x06, 5}, {0x00, 4}, {0x02, 4}, {0x07, 3}, {0x05, 3}, {0x03, 3}, {0x02, 3},
  {0x04, 3}, {0x06, 3}, {0x01, 4}, {0x1e, 7}, {0x3e, 8}, {0x7e, 9}, {0x0fe,10}, {0x1fe,11},
  {0x3fe,12}, {0x7fe,13}, {0x7ff,13}
};

static VLCtable_studio DCtab_chrom_studio[19] =
{
  /*v001225*/
  {0x00, 4}, {0x02, 4}, {0x07, 3}, {0x05, 3}, {0x03, 3}, {0x02, 3}, {0x04, 3}, {0x06, 3},
  {0x01, 4}, {0x06, 5}, {0x0e, 6}, {0x1e, 7}, {0x3e, 8}, {0x7e, 9}, {0x0fe,10}, {0x1fe,11},
  {0x3fe,12}, {0x7fe,13}, {0x7ff,13}
};

static VLCtable_studio studio_coeff[32][32] =
{
  /* MoMuSys-2000FDAM1COR-020606 */
  /* table no.0(first ac:eob) */
  {
        { 0x0005,  4 }, { 0x0003,  4 }, { 0x0003,  5 }, { 0x0005,  6 }, 
        { 0x0004,  7 }, { 0x0003,  7 }, { 0x0005,  8 }, { 0x0000,  0 }, 
        { 0x0004,  4 }, { 0x0005,  7 }, { 0x0009,  9 }, { 0x0021, 11 }, 
        { 0x0041, 12 }, { 0x0081, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0005,  3 }, { 0x0004,  3 }, 
        { 0x0003,  3 }, { 0x0002,  4 }, { 0x0004,  6 }, { 0x0003,  6 }, 
        { 0x0011, 10 }, { 0x0080, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.1 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.2 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.3 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.4 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.5 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.6 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.7 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.8(zero_run) */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0001, 1}, {0x0001, 2},
    {0x0001, 3}, {0x0001, 4}, {0x0001, 5}, {0x0003, 7},
    {0x0005, 8}, {0x0004, 8}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.9 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.10 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.11 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.12 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.13 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.14 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.15 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.16(zero_run+1) */
  {
        { 0x0005,  3 }, { 0x0004,  3 }, { 0x0003,  3 }, { 0x0003,  4 }, 
        { 0x0002,  4 }, { 0x0003,  6 }, { 0x0011, 10 }, { 0x0000,  0 }, 
        { 0x0003,  5 }, { 0x0002,  5 }, { 0x0003,  7 }, { 0x0009,  9 }, 
        { 0x0103, 14 }, { 0x0102, 14 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0002,  3 }, { 0x0002,  6 }, 
        { 0x0005,  8 }, { 0x0021, 11 }, { 0x0083, 13 }, { 0x0101, 14 }, 
        { 0x0201, 15 }, { 0x0082, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.17(level=1) */
  {
        { 0x0005,  5 }, { 0x0003,  3 }, { 0x0004,  4 }, { 0x0003,  4 }, 
        { 0x0003,  5 }, { 0x0005,  8 }, { 0x0081, 13 }, { 0x0000,  0 }, 
        { 0x0005,  4 }, { 0x0004,  5 }, { 0x0003,  6 }, { 0x0009,  9 }, 
        { 0x0083, 13 }, { 0x0082, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0002,  2 }, { 0x0002,  5 }, 
        { 0x0002,  6 }, { 0x0003,  7 }, { 0x0011, 10 }, { 0x0043, 12 }, 
        { 0x0080, 13 }, { 0x0042, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.18(level=2-3) */
  {
        { 0x0005,  7 }, { 0x0003,  3 }, { 0x0002,  4 }, { 0x0005,  6 }, 
        { 0x0003,  7 }, { 0x0011, 10 }, { 0x0201, 15 }, { 0x0000,  0 }, 
        { 0x0003,  4 }, { 0x0003,  5 }, { 0x0004,  7 }, { 0x0009,  9 }, 
        { 0x0083, 13 }, { 0x0101, 14 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0002,  2 }, { 0x0002,  3 }, 
        { 0x0004,  6 }, { 0x0003,  6 }, { 0x0005,  8 }, { 0x0021, 11 }, 
        { 0x0082, 13 }, { 0x0081, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.19(level=4-7) */
  {
        { 0x0013, 10 }, { 0x0002,  5 }, { 0x0004,  7 }, { 0x0005,  8 }, 
        { 0x0023, 11 }, { 0x0081, 13 }, { 0x0101, 14 }, { 0x0000,  0 }, 
        { 0x0003,  5 }, { 0x0005,  7 }, { 0x0012, 10 }, { 0x0043, 12 }, 
        { 0x0083, 13 }, { 0x0082, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0002,  2 }, { 0x0001,  2 }, 
        { 0x0001,  3 }, { 0x0003,  6 }, { 0x0003,  7 }, { 0x0022, 11 }, 
        { 0x0201, 15 }, { 0x0042, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.20(level=8-15) */
  {
        { 0x0023, 11 }, { 0x0003,  6 }, { 0x0006,  8 }, { 0x0012, 10 }, 
        { 0x0043, 12 }, { 0x0101, 14 }, { 0x0201, 15 }, { 0x0000,  0 }, 
        { 0x0001,  4 }, { 0x0007,  8 }, { 0x0013, 10 }, { 0x0022, 11 }, 
        { 0x0103, 14 }, { 0x0102, 14 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  3 }, { 0x0002,  3 }, { 0x0003,  2 }, 
        { 0x0002,  2 }, { 0x0001,  3 }, { 0x0002,  6 }, { 0x0005,  8 }, 
        { 0x0042, 12 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.21(level=16-31) */
  {
        { 0x000b,  9 }, { 0x0005,  7 }, { 0x0006,  8 }, { 0x000a,  9 }, 
        { 0x0013, 10 }, { 0x0022, 11 }, { 0x0040, 12 }, { 0x0000,  0 }, 
        { 0x0003,  5 }, { 0x0007,  8 }, { 0x0007,  7 }, { 0x0006,  7 }, 
        { 0x0023, 11 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  4 }, { 0x0002,  4 }, { 0x0003,  2 }, 
        { 0x0002,  2 }, { 0x0001,  2 }, { 0x0002,  5 }, { 0x0004,  7 }, 
        { 0x0012, 10 }, { 0x0021, 11 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.22(level=32-63) */
  {
        { 0x0015, 10 }, { 0x0006,  8 }, { 0x000b,  9 }, { 0x0013, 10 }, 
        { 0x0012, 10 }, { 0x0042, 12 }, { 0x0080, 13 }, { 0x0000,  0 }, 
        { 0x0003,  6 }, { 0x0014, 10 }, { 0x0023, 11 }, { 0x0007,  8 }, 
        { 0x0043, 12 }, { 0x0081, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0001,  4 }, { 0x0003,  3 }, { 0x0002,  3 }, 
        { 0x0003,  2 }, { 0x0002,  2 }, { 0x0001,  3 }, { 0x0002,  6 }, 
        { 0x0022, 11 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.23(level=64-127) */
  {
        { 0x0043, 12 }, { 0x0005,  7 }, { 0x0004,  7 }, { 0x0006,  8 }, 
        { 0x0012, 10 }, { 0x0041, 12 }, { 0x0040, 12 }, { 0x0000,  0 }, 
        { 0x0005,  6 }, { 0x0007,  8 }, { 0x0004,  6 }, { 0x0003,  6 }, 
        { 0x0013, 10 }, { 0x0042, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  5 }, { 0x0003,  4 }, { 0x0003,  3 }, 
        { 0x0002,  3 }, { 0x0003,  2 }, { 0x0002,  2 }, { 0x0002,  4 }, 
        { 0x0005,  8 }, { 0x0011, 10 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.24(level=128-255) */
  {
        { 0x0083, 13 }, { 0x0004,  7 }, { 0x0006,  8 }, { 0x000b,  9 }, 
        { 0x000a,  9 }, { 0x0011, 10 }, { 0x0080, 13 }, { 0x0000,  0 }, 
        { 0x0005,  7 }, { 0x0007,  8 }, { 0x0003,  4 }, { 0x0021, 11 }, 
        { 0x0082, 13 }, { 0x0081, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  5 }, { 0x0002,  5 }, { 0x0002,  4 }, 
        { 0x0003,  3 }, { 0x0002,  3 }, { 0x0003,  2 }, { 0x0002,  2 }, 
        { 0x0003,  6 }, { 0x0009,  9 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.25(level=ESCAPE) */
  {
        { 0x0013, 10 }, { 0x0002,  5 }, { 0x0002,  6 }, { 0x0007,  8 }, 
        { 0x000b,  9 }, { 0x0012, 10 }, { 0x0011, 10 }, { 0x0000,  0 }, 
        { 0x0003,  5 }, { 0x0003,  6 }, { 0x000d,  9 }, { 0x000c,  9 }, 
        { 0x0021, 11 }, { 0x0020, 11 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0005,  3 }, { 0x0004,  3 }, { 0x0005,  4 }, 
        { 0x0004,  4 }, { 0x0003,  4 }, { 0x0002,  4 }, { 0x0003,  3 }, 
        { 0x0003,  2 }, { 0x000a,  9 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.26 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.27 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.28 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.29 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.30 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.31 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  }
};

static VLCtable_studio studio_coeff_inter[32][32] =
{
  /* table no.0(first ac:eob) */
  {
        { 0x0000,  0 }, { 0x0005,  3 }, { 0x0004,  3 }, { 0x0005,  4 }, 
        { 0x0004,  4 }, { 0x0003,  5 }, { 0x0002,  5 }, { 0x0000,  0 }, 
        { 0x0005,  5 }, { 0x0004,  5 }, { 0x0003,  7 }, { 0x0009,  9 }, 
        { 0x0021, 11 }, { 0x0082, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0003,  3 }, { 0x0003,  4 }, 
        { 0x0003,  6 }, { 0x0002,  6 }, { 0x0005,  8 }, { 0x0011, 10 }, 
        { 0x0081, 13 }, { 0x0080, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.1 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.2 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.3 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.4 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.5 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.6 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.7 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.8(zero_run) */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0001, 1}, {0x0001, 2},
    {0x0001, 3}, {0x0001, 4}, {0x0001, 5}, {0x0003, 7},
    {0x0005, 8}, {0x0004, 8}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.9 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.10 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.11 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.12 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.13 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.14 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.15 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.16(zero_run+1) */
  {
        { 0x0005,  3 }, { 0x0004,  3 }, { 0x0003,  3 }, { 0x0002,  3 }, 
        { 0x0003,  4 }, { 0x0003,  5 }, { 0x0005,  8 }, { 0x0000,  0 }, 
        { 0x0005,  5 }, { 0x0004,  5 }, { 0x0003,  6 }, { 0x0003,  7 }, 
        { 0x0011, 10 }, { 0x0083, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0002,  5 }, { 0x0002,  6 }, 
        { 0x0009,  9 }, { 0x0043, 12 }, { 0x0082, 13 }, { 0x0081, 13 }, 
        { 0x0080, 13 }, { 0x0042, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.17(level=1) */
  {
        { 0x0005,  4 }, { 0x0005,  3 }, { 0x0004,  3 }, { 0x0003,  4 }, 
        { 0x0002,  4 }, { 0x0003,  6 }, { 0x0005,  8 }, { 0x0000,  0 }, 
        { 0x0004,  4 }, { 0x0003,  5 }, { 0x0005,  6 }, { 0x0004,  6 }, 
        { 0x0011, 10 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0003,  3 }, { 0x0002,  6 }, 
        { 0x0003,  7 }, { 0x0009,  9 }, { 0x0021, 11 }, { 0x0101, 14 }, 
        { 0x0201, 15 }, { 0x0081, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.18(level=2-3) */
  {
        { 0x0005,  6 }, { 0x0003,  3 }, { 0x0004,  4 }, { 0x0003,  4 }, 
        { 0x0004,  5 }, { 0x0003,  7 }, { 0x0009,  9 }, { 0x0000,  0 }, 
        { 0x0005,  4 }, { 0x0005,  5 }, { 0x0004,  6 }, { 0x0003,  6 }, 
        { 0x0021, 11 }, { 0x0081, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0002,  2 }, { 0x0003,  5 }, 
        { 0x0002,  6 }, { 0x0005,  8 }, { 0x0011, 10 }, { 0x0101, 14 }, 
        { 0x0201, 15 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.19(level=4-7) */
  {
        { 0x0005,  6 }, { 0x0003,  4 }, { 0x0004,  5 }, { 0x0004,  6 }, 
        { 0x0003,  7 }, { 0x0005,  8 }, { 0x0011, 10 }, { 0x0000,  0 }, 
        { 0x0003,  3 }, { 0x0005,  5 }, { 0x0005,  7 }, { 0x0004,  7 }, 
        { 0x0043, 12 }, { 0x0081, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  2 }, { 0x0002,  2 }, { 0x0002,  3 }, 
        { 0x0003,  5 }, { 0x0003,  6 }, { 0x0009,  9 }, { 0x0042, 12 }, 
        { 0x0080, 13 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.20(level=8-15) */
  {
        { 0x0005,  6 }, { 0x0005,  5 }, { 0x0004,  5 }, { 0x0003,  6 }, 
        { 0x0004,  7 }, { 0x0009,  9 }, { 0x0011, 10 }, { 0x0000,  0 }, 
        { 0x0003,  4 }, { 0x0004,  6 }, { 0x0005,  7 }, { 0x0005,  8 }, 
        { 0x0043, 12 }, { 0x0081, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  3 }, { 0x0003,  2 }, { 0x0002,  2 }, 
        { 0x0002,  3 }, { 0x0003,  5 }, { 0x0003,  7 }, { 0x0042, 12 }, 
        { 0x0080, 13 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.21(level=16-31) */
  {
        { 0x0005,  7 }, { 0x0003,  5 }, { 0x0004,  6 }, { 0x0004,  7 }, 
        { 0x0003,  7 }, { 0x000a,  9 }, { 0x0022, 11 }, { 0x0000,  0 }, 
        { 0x0003,  4 }, { 0x0005,  6 }, { 0x000b,  9 }, { 0x0013, 10 }, 
        { 0x0023, 11 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0003,  3 }, { 0x0002,  3 }, { 0x0003,  2 }, 
        { 0x0002,  2 }, { 0x0002,  4 }, { 0x0003,  6 }, { 0x0012, 10 }, 
        { 0x0040, 12 }, { 0x0021, 11 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.22(level=32-63) */
  {
        { 0x0005,  6 }, { 0x0004,  6 }, { 0x0006,  7 }, { 0x0005,  7 }, 
        { 0x0004,  7 }, { 0x0005,  8 }, { 0x0009,  9 }, { 0x0000,  0 }, 
        { 0x0003,  4 }, { 0x0007,  7 }, { 0x0011, 10 }, { 0x0043, 12 }, 
        { 0x0081, 13 }, { 0x0080, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0002,  4 }, { 0x0003,  3 }, { 0x0002,  3 }, 
        { 0x0003,  2 }, { 0x0002,  2 }, { 0x0003,  5 }, { 0x0003,  7 }, 
        { 0x0042, 12 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.23(level=64-127) */
  {
        { 0x0005,  6 }, { 0x0002,  4 }, { 0x0004,  6 }, { 0x0003,  6 }, 
        { 0x0003,  7 }, { 0x0011, 10 }, { 0x0009,  9 }, { 0x0000,  0 }, 
        { 0x0003,  4 }, { 0x0005,  7 }, { 0x0004,  7 }, { 0x0021, 11 }, 
        { 0x0081, 13 }, { 0x0080, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0007,  3 }, { 0x0006,  3 }, { 0x0005,  3 }, 
        { 0x0004,  3 }, { 0x0003,  3 }, { 0x0002,  3 }, { 0x0003,  5 }, 
        { 0x0005,  8 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.24(level=128-255) */
  {
        { 0x0023, 11 }, { 0x0003,  5 }, { 0x0003,  6 }, { 0x0005,  8 }, 
        { 0x0009,  9 }, { 0x0043, 12 }, { 0x0080, 13 }, { 0x0000,  0 }, 
        { 0x0003,  4 }, { 0x0003,  7 }, { 0x0022, 11 }, { 0x0083, 13 }, 
        { 0x0082, 13 }, { 0x0081, 13 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0005,  3 }, { 0x0004,  3 }, { 0x0003,  2 }, 
        { 0x0003,  3 }, { 0x0002,  4 }, { 0x0002,  3 }, { 0x0002,  5 }, 
        { 0x0002,  6 }, { 0x0042, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.25(level=ESCAPE) */
  {
        { 0x0015, 10 }, { 0x000b,  9 }, { 0x0013, 10 }, { 0x0012, 10 }, 
        { 0x0023, 11 }, { 0x0022, 11 }, { 0x0201, 15 }, { 0x0000,  0 }, 
        { 0x0001,  4 }, { 0x0003,  6 }, { 0x0014, 10 }, { 0x0043, 12 }, 
        { 0x0081, 13 }, { 0x0101, 14 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0001,  3 }, { 0x0003,  2 }, { 0x0002,  2 }, 
        { 0x0001,  2 }, { 0x0007,  8 }, { 0x0006,  8 }, { 0x0002,  6 }, 
        { 0x0042, 12 }, { 0x0041, 12 }, { 0x0000,  0 }, { 0x0000,  0 }, 
        { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }, { 0x0000,  0 }
  },
  /* table no.26 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.27 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.28 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.29 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.30 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  },
  /* table no.31 */
  {
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0},
    {0x0000, 0}, {0x0000, 0}, {0x0000, 0}, {0x0000, 0}
  }
};


#endif /* _VLC_STUDIO_H */






